#! /usr/bin/perl
#Name: R3-status.pl
#Project: R3 control
#Homepage: www.HomoFaciens.de
#Author Norbert Heinz
#Version: 1.0
#Creation date: 08.08.2012
#Copyright: (c) 2012 by Norbert Heinz
#This program is free software you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation version 3 of the License.
#This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#You should have received a copy of the GNU General Public License along with this program if not, see http://www.gnu.org/licenses/.
#
#Server script displays the status of the rover. Script is called by Javascript from control panel of the webpage

use strict;
use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);

my $numArgs = 0;
my $argument_command = "";
my $type_style =  '; font-family:serif,Times,serif; font-size:12px; color:#000000"';
my $file_out = "R3command.txt";
my $Arg01 = param("Arg01");
my $Arg02 = param("Arg02");
my $Arg03 = param("Arg03");
my $Arg04 = param("Arg04");
my $Arg05 = param("Arg05");


if($Arg01 ne ""){
  $numArgs++;
}
if($Arg02 ne ""){
  $numArgs++;
}
if($Arg03 ne ""){
  $numArgs++;
}
if($Arg04 ne ""){
  $numArgs++;
}
if($Arg05 ne ""){
  $numArgs++;
}

print "Content-type: text/html\n\n";
print '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN">' . "\n";
print "<html><head><title>Test-Ausgabe</title>" . "\n";

print "</head><body>";
print '<table border="0" cellpadding="0" cellspacing="0"><tr>' . "\n";


#print '<td style="background-color:#F0F0F0' . $type_style . '">$numArgs=' . $numArgs . ', $Arg01=' . $Arg01 . ', $Arg02=' . $Arg02 . ', $Arg03=' . $Arg03 . ', $Arg04=' . $Arg04 . '</td></tr><tr>';

  if($numArgs < 1){#Script has to be called with at least 1 Argument
    print '<td style="background-color:#FF0000' . $type_style . '">Not enough parameters given!</td>';
  }
  else{
    if($numArgs == 4){#Call with language, Username, UserID and R3 command
      $argument_command = $Arg04;
      $argument_command .= ( "                    ");
      $argument_command = substr($argument_command, 0, 20);

      if($Arg01 eq "ge"){
        print '<td style="background-color:#00FF00' . $type_style . '>R3 steht unter deinem Kommando: "' . $Arg02 . '" mit ID "' . $Arg02 . '"</td>';
      }
      else{
        print '<td style="background-color:#00FF00' . $type_style . '>R3 is under your control: "' . $Arg02 . '" with ID "' . $Arg03 . '"</td>';
      }
      if(-e $file_out){
        if($Arg01 eq "ge"){
          print '</tr><tr><td style="background-color:#FF0000' . $type_style . '>Kommandopipeline noch nicht frei. Versuch es in 5 Sekunden nochmal.</td>';
        }
        else{
          print '</tr><tr><td style="background-color:#FF0000' . $type_style . '>Command pipe not free for new command. Please try again in five seconds.</td>';
        }
      }
      else{
        open(DATEIOUT,'>'.$file_out) || die '<td style="background-color:#FF0000' . $type_style . '>Can not open command file' .  $file_out . '. Please try again.</td></tr></table></body></html>';
          print DATEIOUT $argument_command . $Arg03 . $Arg02 . "_\n";
        close (DATEIOUT);
        $argument_command =~ s/^ +//;
        $argument_command =~ s/ +$//;
        if($Arg01 eq "ge"){
          print '</tr><tr><td style="background-color:#FFFFFF' . $type_style . '>' . $argument_command . ' an R3 &uuml;bermittlet.</td>';
        }
        else{
          print '</tr><tr><td style="background-color:#FFFFFF' . $type_style . '>' . $argument_command . ' sent to R3</td>';
        }
      }
    }#if($numArgs == 4){


    if($numArgs == 3){#Call without transmitted command (fourth argument). Display status.

      if (-e $file_out){

        if($Arg01 eq "ge"){
          print '<td style="background-color:#00FF00' . $type_style . '>R3 steht unter deinem Kommando: "' . $Arg02 . '" mit ID "' . $Arg03 . '"</td>' . "\n";
        }
        else{
          print '<td style="background-color:#00FF00' . $type_style . '>R3 is under your control: "' . $Arg02 . '" with ID "' . $Arg03 . '"</td>' . "\n";
        }
        if (-e "R3command.txt"){
          if($Arg01 eq "ge"){
            print '</tr><tr><td style="background-color:#FFFFFF' . $type_style . '>Verarbeite aktuellen Befehl - bitte warten (normalerweise 10 bis 30Sekunden bis zum neuen Bild).</td>' . "\n";
          }
          else{
            print '</tr><tr><td style="background-color:#FFFFFF' . $type_style . '>Processing current command - please wait (usually 10 to 30 seconds) for new pic.</td>' . "\n";
          }
        }
        else{
          if($Arg01 eq "ge"){
            print '</tr><tr><td style="background-color:#FFFF00' . $type_style . '>Hallo Kontrollstation auf dem Planeten Erde, klick "Befehl senden", um den Befehlssatz zu starten!</td>' . "\n";
          }
          else{
            print '</tr><tr><td style="background-color:#FFFF00' . $type_style . '>Hello control station on planet Earth, press "send command" to transmit instruction set!</td>' . "\n";
          }
        }
      }
      else{
        if($Arg01 eq "ge"){
          print '<td style="background-color:#FFFF00' . $type_style . '>R3 steht zur Verf&uuml;gung. Klick "Befehl senden", um die Kontrolle zu &uuml;bernehmen...</td>' . "\n";
        }
        else{
          print '<td style="background-color:#FFFF00' . $type_style . '>R3 free for use. Press "Send command" to take control...</td>' . "\n";
        }
      }
        
    }#if($numArgs  == 3){
  }#if($numArgs < 1){


print "</tr></table></body></html>" . "\n";

exit (0);



